import logging
import os
import threading
import time
import webbrowser

from uvicorn import run
from aiconsole.patched_interpreter.utils.display_markdown_message import display_markdown_message

from aiconsole.utils.is_update_needed import is_update_needed

log = logging.getLogger(__name__)


def run_aiconsole(dev: bool):
    threads = []

    if dev: 
        threads.append(threading.Thread(target= lambda: os.system("cd web && yarn dev"))) 
        threads.append(threading.Thread(target= lambda: webbrowser.open("http://localhost:3000/"))) 
    else:
        threads.append(threading.Thread(target= lambda: webbrowser.open("http://localhost:8000/")))
    
    for thread in threads:
        thread.start()

    try:
        run(
            "aiconsole.app:app",
            host="0.0.0.0",
            port=8000,
            reload=dev,
            factory=True,
        )
    except KeyboardInterrupt:
        log.info("Exiting ...")

        for thread in threads:
            thread.join()


def aiconsole_dev():
    run_aiconsole(dev=True)


def aiconsole():
    run_aiconsole(dev=False)
